diff --git a/drupal7/sites/all/modules/media/media.module b/drupal7/sites/all/modules/media/media.module
index 3c54914a..1f97bcb7 100644
--- a/drupal7/sites/all/modules/media/media.module
+++ b/drupal7/sites/all/modules/media/media.module
@@ -358,8 +358,9 @@ function media_form_field_ui_field_edit_form_alter(&$form, &$form_state) {
   }
 
   // Add a validation function to any field instance which uses the media widget
-  // to ensure that the upload destination scheme is one of the allowed schemes.
-  if ($form['instance']['widget']['type']['#value'] == 'media_generic') {
+  // to ensure that the upload destination scheme is one of the allowed schemes
+  // if any defined by settings.
+  if ($form['instance']['widget']['type']['#value'] == 'media_generic' && isset($form['#field']['settings']['uri_scheme'])) {
     $form['#validate'][] = 'media_field_instance_validate';
   }
 
@@ -378,10 +379,10 @@ function media_form_field_ui_field_edit_form_alter(&$form, &$form_state) {
  * allowed schemes.
  */
 function media_field_instance_validate($form, &$form_state) {
-  $allowed_schemes = $form_state['values']['instance']['widget']['settings']['allowed_schemes'];
+  $allowed_schemes = array_filter($form_state['values']['instance']['widget']['settings']['allowed_schemes']);
   $upload_destination = $form_state['values']['field']['settings']['uri_scheme'];
 
-  if (!in_array($upload_destination, array_filter($allowed_schemes))) {
+  if (!empty($allowed_schemes) && !in_array($upload_destination, $allowed_schemes)) {
     form_set_error('allowed_schemes', t('The upload destination must be one of the allowed schemes.'));
   }
 }
@@ -393,8 +394,13 @@ function media_form_alter(&$form, &$form_state, $form_id) {
   // If we're in the media browser, set the #media_browser key to true
   // so that if an ajax request gets sent to a different path, the form
   // still uses the media_browser_form_submit callback.
-  if (current_path() == 'media/browser' && $form_id != 'views_exposed_form') {
-    $form_state['#media_browser'] = TRUE;
+  if (current_path() == 'media/browser') {
+    if ($form_id == 'views_exposed_form') {
+      $form['render'] = array('#type' => 'hidden', '#value' => 'media-popup');
+      $form['#action'] = '/media/browser';
+    } else {
+      $form_state['#media_browser'] = TRUE;
+    }
   }
 
   // If the #media_browser key isset and is true we are using the browser
@@ -478,6 +484,47 @@ function media_library() {
     ),
   );
 
+  // Settings for the dialog etc.
+  $settings = array(
+    'browserUrl' => url('media/browser', array(
+      'query' => array(
+        'render' => 'media-popup'
+      ))
+    ),
+    'styleSelectorUrl' => url('media/-media_id-/format-form', array(
+      'query' => array(
+        'render' => 'media-popup'
+      ))
+    ),
+    'dialogOptions' => array(
+      'dialogclass' => variable_get('media_dialogclass', 'media-wrapper'),
+      'modal' => (boolean)variable_get('media_modal', TRUE),
+      'draggable' => (boolean)variable_get('media_draggable', FALSE),
+      'resizable' => (boolean)variable_get('media_resizable', FALSE),
+      'minwidth' => (int)variable_get('media_minwidth', 500),
+      'width' => (int)variable_get('media_width', 670),
+      'height' => (int)variable_get('media_height', 280),
+      'position' => variable_get('media_position', 'center'),
+      'overlay' => array(
+        'backgroundcolor' => variable_get('media_backgroundcolor', '#000000'),
+        'opacity' => (float)variable_get('media_opacity', 0.4),
+      ),
+      'zindex' => (int)variable_get('media_zindex', 10000),
+    ),
+  );
+
+  $libraries['media_browser_settings'] = array(
+    'title' => 'Media browser settings',
+    'js' => array(
+      0 => array(
+        'data' => array(
+          'media' => $settings,
+        ),
+        'type' => 'setting',
+      ),
+    ),
+  );
+
   foreach ($libraries as &$library) {
     $library += $common;
   }
@@ -538,6 +585,11 @@ function media_parse_to_uri($url) {
   $url = trim($url);
   foreach (module_implements('media_parse') as $module) {
     $success = module_invoke($module, 'media_parse', $url);
+    $context = array(
+      'url' => $url,
+      'module' => $module,
+    );
+    drupal_alter('media_parse', $success, $context);
     if (isset($success)) {
       return $success;
     }
@@ -660,6 +712,11 @@ function media_element_process($element, &$form_state, $form) {
   ctools_include('modal');
   ctools_include('ajax');
   ctools_modal_add_js();
+
+  // Append the '-upload' to the #id so the field label's 'for' attribute
+  // corresponds with the textfield element.
+  $original_id = $element['#id'];
+  $element['#id'] .= '-upload';
   $fid = isset($element['#value']['fid']) ? $element['#value']['fid'] : 0;
 
   // Set some default element properties.
@@ -668,7 +725,7 @@ function media_element_process($element, &$form_state, $form) {
 
   $ajax_settings = array(
     'path' => 'media/ajax/' . implode('/', $element['#array_parents']) . '/' . $form['form_build_id']['#value'],
-    'wrapper' => $element['#id'] . '-ajax-wrapper',
+    'wrapper' => $original_id . '-ajax-wrapper',
     'effect' => 'fade',
   );
 
@@ -769,11 +826,11 @@ function media_element_process($element, &$form_state, $form) {
     )
   );
 
-  module_load_include('inc', 'media', 'includes/media.browser');
-  media_attach_browser_js($element);
+  $element['#attached']['library'][] = array('media', 'media_browser');
+  $element['#attached']['library'][] = array('media', 'media_browser_settings');
 
   // Prefix and suffix used for Ajax replacement.
-  $element['#prefix'] = '<div id="' . $element['#id'] . '-ajax-wrapper">';
+  $element['#prefix'] = '<div id="' . $original_id . '-ajax-wrapper">';
   $element['#suffix'] = '</div>';
 
   return $element;
@@ -1015,28 +1072,35 @@ function media_element_pre_render($element) {
 }
 
 /**
- * Media thumbnail render function.
+ * Generates a thumbnail preview of a file.
  *
- * Returns a renderable array with the necessary classes to support a media
- * thumbnail. Also provides default fallback images if no image is available.
+ * Provides default fallback images if an image of the file cannot be generated.
  *
  * @param object $file
  *   A Drupal file object.
+ * @param boolean $link
+ *   (optional) Boolean indicating whether the thumbnail should be linked to the
+ *   file. Defaults to FALSE.
+ * @param string $view_mode
+ *   (optional) The view mode to use when rendering the thumbnail. Defaults to
+ *   'preview'.
  *
  * @return array
- *   Renderable array.
+ *   Renderable array suitable for drupal_render() with the necessary classes
+ *   and CSS to support a media thumbnail.
  */
-function media_get_thumbnail_preview($file, $link = NULL) {
+function media_get_thumbnail_preview($file, $link = FALSE, $view_mode = 'preview') {
   // If a file has an invalid type, allow file_view_file() to work.
   if (!file_type_is_enabled($file->type)) {
     $file->type = file_get_type($file);
   }
 
-  $preview = file_view_file($file, 'preview');
+  $preview = file_view_file($file, $view_mode);
   $preview['#show_names'] = TRUE;
   $preview['#add_link'] = $link;
   $preview['#theme_wrappers'][] = 'media_thumbnail';
   $preview['#attached']['css'][] = drupal_get_path('module', 'media') . '/css/media.css';
+
   return $preview;
 }
 
@@ -1278,6 +1342,9 @@ function media_load_all_exports($module, $directory, $extension, $name = NULL) {
 /**
  * Returns metadata describing Media browser plugins.
  *
+ * @return
+ *   An associative array of plugin information, keyed by plugin.
+ *
  * @see hook_media_browser_plugin_info()
  * @see hook_media_browser_plugin_info_alter()
  */
@@ -1285,15 +1352,8 @@ function media_get_browser_plugin_info() {
   $info = &drupal_static(__FUNCTION__);
 
   if (!isset($info)) {
-    $cid = 'media:browser:plugin:info:' . $GLOBALS['language']->language;
-    if ($cache = cache_get($cid)) {
-      $info = $cache->data;
-    }
-    else {
-      $info = module_invoke_all('media_browser_plugin_info');
-      drupal_alter('media_browser_plugin_info', $info);
-      cache_set($cid, $info);
-    }
+    $info = module_invoke_all('media_browser_plugin_info');
+    drupal_alter('media_browser_plugin_info', $info);
   }
 
   return $info;
diff --git a/drupal7/sites/all/modules/media/media.views.inc b/drupal7/sites/all/modules/media/media.views.inc
index 9d116bfc..aed55fa4 100644
--- a/drupal7/sites/all/modules/media/media.views.inc
+++ b/drupal7/sites/all/modules/media/media.views.inc
@@ -74,10 +74,13 @@ function template_preprocess_media_views_view_media_browser(&$vars) {
   $files = file_load_multiple($fids);
 
   // Render the preview for each file.
+  $params = media_get_browser_params();
+  $view_mode = isset($params['view_mode']) ? $params['view_mode'] : 'preview';
+
   foreach ($vars['rows'] as $index => $row) {
     $file = $files[$row->fid];
     // Add url/preview to the file object.
-    media_browser_build_media_item($file);
+    media_browser_build_media_item($file, $view_mode);
     $vars['rows'][$index] = $file;
     $vars['rows'][$index]->preview = $file->preview;
   }
@@ -126,6 +129,5 @@ function template_preprocess_media_views_view_media_browser(&$vars) {
  * Implements hook_views_invalidate_cache().
  */
 function media_views_invalidate_cache() {
-  cache_clear_all('media:browser:plugin', 'cache', TRUE);
   drupal_static_reset('media_get_browser_plugin_info');
 }
diff --git a/drupal7/sites/all/modules/media/modules/media_bulk_upload/includes/media_bulk_upload.pages.inc b/drupal7/sites/all/modules/media/modules/media_bulk_upload/includes/media_bulk_upload.pages.inc
index 50d0b560..41287ebb 100644
--- a/drupal7/sites/all/modules/media/modules/media_bulk_upload/includes/media_bulk_upload.pages.inc
+++ b/drupal7/sites/all/modules/media/modules/media_bulk_upload/includes/media_bulk_upload.pages.inc
@@ -27,13 +27,42 @@ function media_bulk_upload_file_page_edit_multiple($files) {
   $form = call_user_func_array('multiform_get_form', $forms);
   $form['#attributes']['class'][] = 'media-bulk-upload-multiedit-form';
 
-  // Add the title to each 'subform'.
+  // Improve the display of each file form.
   foreach (element_children($form['multiform']) as $key) {
     $fid = $form['multiform'][$key]['fid']['#value'];
     $file = $files[$fid];
+
+    // Add the filename to each 'subform'.
     $title = t('<em>Edit @type</em> @title', array('@type' => $file->type, '@title' => $file->filename));
     $form['multiform'][$key]['#prefix'] = '<h2>' . $title . '</h2>';
+
+    // Remove the 'replace file' functionality.
+    $form['multiform'][$key]['replace_upload']['#access'] = FALSE;
+
+    // Remove any actions.
     $form['multiform'][$key]['actions']['#access'] = FALSE;
+
+    // Hide additional settings under a collapsible fieldset.
+    $form['multiform'][$key]['settings'] = array(
+      '#type' => 'fieldset',
+      '#title' => t('Additional settings'),
+      '#weight' => 99,
+      '#collapsible' => TRUE,
+      '#collapsed' => TRUE,
+      // FAPI #collapsed and #collapsible not available in a render array.
+      '#attached' => array(
+        'js' => array(
+          'misc/form.js',
+          'misc/collapse.js',
+        ),
+      ),
+      '#attributes' => array(
+        'class' => array('collapsible', 'collapsed'),
+      ),
+    );
+
+    $form['multiform'][$key]['settings']['additional_settings'] = $form['multiform'][$key]['additional_settings'];
+    unset($form['multiform'][$key]['additional_settings']);
   }
 
   if (isset($form['buttons']['Delete'])) {
diff --git a/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.info b/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.info
index a4414f9f..9763f529 100644
--- a/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.info
+++ b/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.info
@@ -7,11 +7,15 @@ dependencies[] = media
 dependencies[] = multiform
 dependencies[] = plupload
 
+test_dependencies[] = multiform
+test_dependencies[] = plupload
+
 files[] = includes/MediaBrowserBulkUpload.inc
+files[] = tests/media_bulk_upload.test
 
-; Information added by Drupal.org packaging script on 2014-10-04
-version = "7.x-2.0-alpha4"
+; Information added by Drupal.org packaging script on 2015-07-14
+version = "7.x-2.0-beta1"
 core = "7.x"
 project = "media"
-datestamp = "1412422430"
+datestamp = "1436895542"
 
diff --git a/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.module b/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.module
index aba72f86..9bd0d7af 100644
--- a/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.module
+++ b/drupal7/sites/all/modules/media/modules/media_bulk_upload/media_bulk_upload.module
@@ -154,11 +154,16 @@ function media_bulk_upload_forms($form_id, $args) {
   if ($form_id != 'media_edit' && (strpos($form_id, 'media_edit') === 0)) {
     $forms[$form_id] = array(
       'callback' => 'file_entity_edit',
+      'wrapper_callback' => 'media_bulk_upload_prepare_edit_form',
     );
   }
   return $forms;
 }
 
+function media_bulk_upload_prepare_edit_form($form, &$form_state) {
+  form_load_include($form_state, 'inc', 'file_entity', 'file_entity.pages');
+}
+
 /**
  * Access callback for the media-multi form.
  *
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/media_internet.api.php b/drupal7/sites/all/modules/media/modules/media_internet/media_internet.api.php
index 75548f63..4a6afc5a 100644
--- a/drupal7/sites/all/modules/media/modules/media_internet/media_internet.api.php
+++ b/drupal7/sites/all/modules/media/modules/media_internet/media_internet.api.php
@@ -6,20 +6,42 @@
  */
 
 /**
- * Implements hook_media_internet_providers().
+ * Returns a list of Internet media providers for URL/embed code testing.
  *
- * Implementors return an multidim array, keyed by a class name with the
- * following elements:
- * - title
- * - image (optional)
- * - hidden: bool If the logo should be shown on form. (optional)
- * - weight (optional)
+ * @return array
+ *   A nested array of provider information, keyed by class name. This class
+ *   must implement a claim() method and may (should) extend the
+ *   @link MediaInternetBaseHandler MediaInternetBaseHandler @endlink class.
+ *   Each provider info array may have the following keys:
+ *   - title: (required) A name to be used when listing the currently supported
+ *     providers on the web tab of the media browser.
+ *   - hidden: (optional) Boolean to prevent the provider title from being
+ *     listed on the web tab of the media browser.
+ *   - weight: (optional) Integer to determine the tab order. Defaults to 0.
+ *
+ * @see hook_media_internet_providers_alter()
+ * @see media_internet_get_providers()
  */
 function hook_media_internet_providers() {
   return array(
-    'youtube' => array(
-      'title' => 'youtube',
-      'image' => 'youtube.jpg',
+    'MyModuleYouTubeHandler' => array(
+      'title' => t('YouTube'),
+      'hidden' => TRUE,
     ),
   );
 }
+
+/**
+ * Alter the list of Internet media providers.
+ *
+ * @param array $providers
+ *   The associative array of Internet media provider definitions from
+ *   hook_media_internet_providers().
+ *
+ * @see hook_media_internet_providers()
+ * @see media_internet_get_providers()
+ */
+function hook_media_internet_providers_alter(&$providers) {
+  $providers['MyModuleYouTubeHandler']['title'] = t('Google video hosting');
+  $providers['MyModuleYouTubeHandler']['weight'] = 42;
+}
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/media_internet.info b/drupal7/sites/all/modules/media/modules/media_internet/media_internet.info
index a01f8a2d..56ee5796 100644
--- a/drupal7/sites/all/modules/media/modules/media_internet/media_internet.info
+++ b/drupal7/sites/all/modules/media/modules/media_internet/media_internet.info
@@ -12,9 +12,9 @@ files[] = includes/MediaInternetNoHandlerException.inc
 files[] = includes/MediaInternetValidationException.inc
 files[] = tests/media_internet.test
 
-; Information added by Drupal.org packaging script on 2014-10-04
-version = "7.x-2.0-alpha4"
+; Information added by Drupal.org packaging script on 2015-07-14
+version = "7.x-2.0-beta1"
 core = "7.x"
 project = "media"
-datestamp = "1412422430"
+datestamp = "1436895542"
 
diff --git a/drupal7/sites/all/modules/media/modules/media_internet/media_internet.module b/drupal7/sites/all/modules/media/modules/media_internet/media_internet.module
index c60fbd80..d94b4792 100644
--- a/drupal7/sites/all/modules/media/modules/media_internet/media_internet.module
+++ b/drupal7/sites/all/modules/media/modules/media_internet/media_internet.module
@@ -61,35 +61,39 @@ function media_internet_theme() {
 }
 
 /**
- * Gets the list of providers.
+ * Gets the list of Internet media providers.
  *
- * A "Provider" is a bit of meta-data like a title and a logo and a class which
- * can handle saving remote files.  Each provider is able to parse an embed code or URL
- * and store it as a file object in file_managed.
+ * Each 'Provider' has a title and a class which can handle saving remote files.
+ * Providers are each given a turn at parsing a user-submitted URL or embed code
+ * and, if they recognize that it belongs to a service or protocol they support,
+ * they store a representation of it as a file object in file_managed.
+ *
+ * @return array
+ *   An associative array of provider information keyed by provider name.
  */
 function media_internet_get_providers() {
   $providers = &drupal_static(__FUNCTION__);
 
   if (!isset($providers)) {
-    $cid = 'media:internet:providers';
-    if ($cache = cache_get($cid)) {
-      $providers = $cache->data;
-    }
-    else {
-      $providers = array();
-      foreach (module_implements('media_internet_providers') as $module) {
-        foreach (module_invoke($module, 'media_internet_providers') as $key => $provider) {
-          // Store the module here too for convinience.
-          $providers[$key] = $provider;
-          $providers[$key]['module'] = $module;
-          if (!isset($providers[$key]['weight'])) {
-            $providers[$key]['weight'] = 0;
-          }
+    foreach (module_implements('media_internet_providers') as $module) {
+      foreach (module_invoke($module, 'media_internet_providers') as $class => $info) {
+        $providers[$class] = $info;
+
+        // Store the name of the module which declared the provider.
+        $providers[$class]['module'] = $module;
+
+        // Assign a default value to providers which don't specify a weight.
+        if (!isset($providers[$class]['weight'])) {
+          $providers[$class]['weight'] = 0;
         }
       }
-      uasort($providers, 'drupal_sort_weight');
-      cache_set($cid, $providers);
     }
+
+    // Allow modules to alter the list of providers.
+    drupal_alter('media_internet_providers', $providers);
+
+    // Sort the providers by weight.
+    uasort($providers, 'drupal_sort_weight');
   }
 
   return $providers;
@@ -201,7 +205,7 @@ function media_internet_form_file_entity_add_upload_alter(&$form, &$form_state,
       $form['embed_code']['#title'] = t('File URL or media resource');
       $form['embed_code']['#description'] = t('Enter a URL to a file or media resource. Many media providers also support identifying media via the embed code used to embed the media into external websites.');
 
-      $form['embed_code']['#description'] = theme('media_internet_embed_help', array('description' => $form['embed_code']['#description'], 'supported_providers' => implode(' ', $providers)));
+      $form['embed_code']['#description'] = theme('media_internet_embed_help', array('description' => $form['embed_code']['#description'], 'supported_providers' => implode(', ', $providers)));
     }
 
     $form['#validators'] = array();
